package
{
  import flash.geom.Point;
  import flash.geom.Matrix;
  import flash.display.Sprite;

  public class GameObject extends Sprite 
  {
    public var pos: Point;
    public var dir: Point;
    public var angle: Number;
    public var vel: Point;
    public var angVel: Number;
    public var acc: Point;
    public var time: Number;
    public var level: Number;
    public var matrix: Matrix;

    public function GameObject(type: Number)
    {
      var i: Number;

      this.pos = new Point();
      this.dir = new Point();
      this.angle = 0;
      this.vel = new Point();
      this.angVel = 0;
      this.acc = new Point();
      this.time = 0;
      this.level = 0;
      matrix = new Matrix();
      visible = false;
      
      switch (type) 
      {
	case 0: // ship
        {
          graphics.lineStyle(2, 0xFFFFFF);
          graphics.beginFill(0xFF0000);
          graphics.moveTo(10, 0);
          graphics.lineTo(-10, 5);
          graphics.lineTo(-10, -5);
          graphics.lineTo(10, 0);
          graphics.endFill();
          break;
        }
	case 1: // shield
        {
          graphics.lineStyle(1, 0xFFFFFF);
          graphics.drawCircle(0, 0, 11);
          break;
        }
	case 2: // bullet
        {
          graphics.lineStyle(2, 0x00FF00);
          graphics.moveTo(10, 1);
          graphics.lineTo(17, 1);
          graphics.lineTo(17, -1);
          graphics.lineTo(10, -1);
          graphics.lineTo(10, 1);
          break;
        }
	case 3: // asteroid
        {
          graphics.lineStyle(1, 0xAAAAAA);
          graphics.beginFill(0x4444FF);
          graphics.moveTo(9, 0);
          for (i = 1; i < 9; i++)
          {
            graphics.lineTo(Math.cos(i * 40 * 0.0174532) * (Math.random() * 4 + 6), Math.sin(i * 40 * 0.0174532) * (Math.random() * 4 + 6));
          }
          graphics.endFill();
          break;
	}
	case 4: // damage
        {
          graphics.lineStyle(1, 0x808080);
          graphics.beginFill(0x808080);
          graphics.moveTo(0, 0);
          graphics.lineTo(100, 0);
          graphics.lineTo(100, 10);
          graphics.lineTo(0, 10);
          graphics.lineTo(0, 0);
          graphics.endFill();
          break;
	}
	case 5: // life
        {
          graphics.lineStyle(1, 0xFF0000);
          graphics.beginFill(0xFF0000);
          graphics.moveTo(0, 0);
          graphics.lineTo(100, 0);
          graphics.lineTo(100, 10);
          graphics.lineTo(0, 10);
          graphics.lineTo(0, 0);
          graphics.endFill();
          break;
	}
      }
    }
  }
}
